'$INCLUDE 'cdi_incl.cbh'

' -------------------------------------------------------------------------------------------------
' Macro to retrieve the line angle and inverse angle of a
' selected line segment.
' Written by Mathew Lawrence, CAlibre Support Services Ltd
' Last modified  Jan 97 by Alan James Wooldridge
' To display results in Degrees, Minutes and Seconds.
' -------------------------------------------------------------------------------------------------

dim object as CDI_OSL_OBJECT
dim vid1 as integer
dim vid2 as integer
dim LineAngle as double
dim RevLineAngle as double
dim op as integer
dim p1 as CDI_DD_POINT
dim p2 as CDI_DD_POINT
dim line_buffer as CDI_LINESET_BUFFER
dim degrees as integer
dim minutes as integer
dim seconds as integer
dim Rdegrees as integer
dim Rminutes as integer
dim Rseconds as integer
sub main


   'Display Copyright Message
'   MsgBox "Get Angle Macro", 64, "Copyright (C) 1996 CAlibre"  Sorry Mathew, Rem'd out, it drives me mad !
   cv_osl = 0
   null_ptr = 0
   dimension_osl = CdiCreateLocalOsl(CDI_OBJECT_COLOR, null_ptr, CDI_REDRAW_OSL)
AGAIN:   
   ' initialize a variable used to define the Cadvance OSL 
   cv_osl = 0
   Call CdiOslClear(cv_osl)
   i_ret = CdiSelectbyPoint(cv_osl, "Select line segment to query, button 2 to exit",CDI_OBJECT_SELECTION, CDI_FALSE, CDI_TRUE, c1, CDI_SEL2D_ALL)
   if i_ret = CDI_ABORT then
	call CdiOslClear(cv_osl)
	exit sub
   elseif i_ret = CDI_ERROR then
	print "Nothing Selected"
   end if
 
   i_ret = CdiOslItem(cv_osl, 0, object)
   l_ret = CdiSelectLineSegment(object.sid, c1, vid1, vid2)
   vid1 = vid1 - 1
   vid2 = vid2 - 1
   l_ret = CdiObjInfo(object.sid, line_buffer) 
   i_ret = CdiObjInfoxy(p1, op, vid1, line_buffer)
   i_ret = CdiObjInfoxy(p2, op, vid2, line_buffer)

   call CdiPang(p1, p2, LineAngle)
   call CdiPang(p2, p1, RevLineAngle)

'----------------------------------------------------------------------------------------

	Degrees = FIX (LineAngle)
	Minutes = FIX ((LineAngle - Degrees)*60)
	Seconds = FIX ((((LineAngle - Degrees)*60)-Minutes)*60)

	RDegrees = FIX (RevLineAngle)
	RMinutes = FIX ((RevLineAngle - RDegrees)*60)
	RSeconds = FIX ((((RevLineAngle - RDegrees)*60)-RMinutes)*60)


		msg1$ = "Degrees = " + str( Degrees )
		msg2$ = "Minutes  = " + str(Minutes)
		msg3$ = "Seconds = " + str(Seconds)
		msg1a$ = "Inverse Degrees = " + str( RDegrees )
		msg2a$ = "Inverse Minutes  = " + str( RMinutes )
		msg3a$ = "Inverse Seconds = " + str( RSeconds )
		msg4$ = "Single Precision"
		msg5$ = "Angle of selected line segment is " + str(CSng(LineAngle))
		msg6$ = "Inverse of Selected Line Angle is " + str(CSng(RevLineAngle))
		msg7$ = "Double Precision"
		msg8$ = "Angle of selected line segment is " + str(LineAngle)
		msg9$ = "Inverse of Selected Line Angle is " + str(RevLineAngle)

		Call CdiPutInfoMsg (" Results of GETANG2.CBX on Selected Line Segment "+Chr$(0),  msg1 + Chr$(13) + msg2 + Chr$(13) +msg3 + Chr$(13)+ Chr$(13) + msg1a + Chr$(13) + msg2a + Chr$(13) +msg3a + Chr$(13)+ Chr$(13) + msg4 + Chr$(13) + msg5 + Chr$(13) + msg6 + Chr$(13)+ Chr$(13) + msg7 + Chr$(13) + msg8 + Chr$(13)  + msg9 + Chr$(13)  +Chr$(0))
 		
' First Msgbox displays results as single precision and 
' Second Msgbox displays results as double precision

'   msgbox "Angle of selected line segment is " + str(CSng(LineAngle)) + " and inverse is " + str(CSng(RevLineAngle)), 64, "Copyright (C) 1996 CAlibre"
'   msgbox "Angle of selected line segment is " + str(LineAngle) + " and inverse is " + str(RevLineAngle), 64, "Copyright (C) 1996 CAlibre"

   call CdiStatusLineUpdate()

goto AGAIN
end sub
